#include "stdafx.h"
using namespace GgafCore;
using namespace GgafDxCore;

#define returnWhenFailed(HR, OKVAL, X) { \
    if (HR != OKVAL) { \
        std::stringstream ss; \
        ss << X; \
        MessageBox(GgafDxGod::_pHWndPrimary, TEXT(ss.str().c_str()), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND); \
        return E_FAIL; \
    } \
}

//TODO:RgƂBB



HWND GgafDxGod::_pHWndPrimary = NULL;
HWND GgafDxGod::_pHWndSecondary = NULL;

IDirect3D9* GgafDxGod::_pID3D9 = NULL;
IDirect3DDevice9* GgafDxGod::_pID3DDevice9 = NULL;
D3DLIGHT9 GgafDxGod::_d3dlight9_default;
DWORD GgafDxGod::_dwAmbientBrightness_default = 0xff404040;


D3DFILLMODE GgafDxGod::_d3dfillmode = D3DFILL_SOLID;//D3DFILL_WIREFRAME;//D3DFILL_SOLID;

GgafDxModelManager* GgafDxGod::_pModelManager = NULL;
GgafDxEffectManager* GgafDxGod::_pEffectManager = NULL;
GgafDxTextureManager* GgafDxGod::_pCubeMapTextureManager = NULL;

bool GgafDxGod::_is_device_lost_flg = false;
bool GgafDxGod::_adjustGameScreen = false;
HWND GgafDxGod::_pHWnd_adjustScreen = NULL;


UINT32 GgafDxGod::_vs_v = 0;
UINT32 GgafDxGod::_ps_v = 0;


#define IFC(x) { hr = (x); if (FAILED(hr)) goto Cleanup; }
#define IFCOOM(x) { if ((x) == NULL) { hr = E_OUTOFMEMORY; IFC(hr); } }
#define SAFE_RELEASE(x) { if (x) { x->Release(); x = NULL; } }


GgafDxGod::GgafDxGod(HINSTANCE prm_hInstance, HWND prm_pHWndPrimary, HWND prm_pHWndSecondary) :
    GgafGod(prm_hInstance) {
    TRACE("GgafDxGod::GgafDxGod() ");

    GgafDxGod::_pHWndPrimary = prm_pHWndPrimary;
    GgafDxGod::_pHWndSecondary = prm_pHWndSecondary;
    _is_device_lost_flg = false;
    _adjustGameScreen = false;
    _pHWnd_adjustScreen = NULL;
    CmRandomNumberGenerator::getInstance()->changeSeed(19740722UL); //19740722 Seed
    GgafRgb rgb_border = GgafRgb(GGAF_PROPERTY(BORDER_COLOR));
    _color_border = D3DCOLOR_RGBA(rgb_border._R, rgb_border._G, rgb_border._B, 0);
    GgafRgb rgb_bg = GgafRgb(GGAF_PROPERTY(BG_COLOR));
    _color_clear = D3DCOLOR_RGBA(rgb_bg._R, rgb_bg._G, rgb_bg._B, 0);
    _pRenderTexture = NULL;
    _pRenderTextureSurface = NULL;
    _pRenderTextureZ = NULL;
    _num_adapter = 1;
    _apSwapChain[0] = NULL;
    _apBackBuffer[0] = NULL;
    _apSwapChain[1] = NULL;
    _apBackBuffer[1] = NULL;

    _secondary_screen_x = 0;
    _secondary_screen_y = 0;

    //[FRECT\]
    //ɎgpRECT\̂̃o right, bottom ́uEWvƂȂĂ邪\mł͂ȂB
    //ۂ̒`
    //rect.right = rect.left + `;
    //rect.bottom = rect.top + `;
    //܂ (10,10)-(17,17) ̈́ARECT(10,10,18,18) Ǝw肷̂Ӑ}gp@炵B
    //₱AAӂ̒߂ꍇ͕֗łB
    //i{̉EẂAright, bottom  -1 ̒lɂȂj
    _rectGameBuffer.left   = 0;
    _rectGameBuffer.top    = 0;
    _rectGameBuffer.right  = _rectGameBuffer.left + GGAF_PROPERTY(GAME_BUFFER_WIDTH);
    _rectGameBuffer.bottom = _rectGameBuffer.top  + GGAF_PROPERTY(GAME_BUFFER_HEIGHT);

    _rectRenderTargetBuffer.left   = 0;
    _rectRenderTargetBuffer.top    = 0;
    _rectRenderTargetBuffer.right  = _rectRenderTargetBuffer.left + GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH);
    _rectRenderTargetBuffer.bottom = _rectRenderTargetBuffer.top  + GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT);

    if (GGAF_PROPERTY(SWAP_GAME_VIEW)) {
        _primary = 1;
        _secondary = 0;
    } else {
        _primary = 0;
        _secondary = 1;
    }
    _aRect_HarfGameBuffer[_primary].left   = 0;
    _aRect_HarfGameBuffer[_primary].top    = 0;
    _aRect_HarfGameBuffer[_primary].right  = _aRect_HarfGameBuffer[_primary].left  + GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
    _aRect_HarfGameBuffer[_primary].bottom = _aRect_HarfGameBuffer[_primary].top + GGAF_PROPERTY(GAME_BUFFER_HEIGHT);

    _aRect_HarfGameBuffer[_secondary].left   = GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
    _aRect_HarfGameBuffer[_secondary].top    = 0;
    _aRect_HarfGameBuffer[_secondary].right  = _aRect_HarfGameBuffer[_secondary].left + GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
    _aRect_HarfGameBuffer[_secondary].bottom = _aRect_HarfGameBuffer[_secondary].top  + GGAF_PROPERTY(GAME_BUFFER_HEIGHT);

    _aRect_HarfRenderTargetBuffer[_primary].left   = 0;
    _aRect_HarfRenderTargetBuffer[_primary].top    = 0;
    _aRect_HarfRenderTargetBuffer[_primary].right  = _aRect_HarfRenderTargetBuffer[_primary].left  + GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH)/2;
    _aRect_HarfRenderTargetBuffer[_primary].bottom = _aRect_HarfRenderTargetBuffer[_primary].top + GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT);

    _aRect_HarfRenderTargetBuffer[_secondary].left   = GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH)/2;
    _aRect_HarfRenderTargetBuffer[_secondary].top    = 0;
    _aRect_HarfRenderTargetBuffer[_secondary].right  = _aRect_HarfRenderTargetBuffer[_secondary].left + GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH)/2;
    _aRect_HarfRenderTargetBuffer[_secondary].bottom = _aRect_HarfRenderTargetBuffer[_secondary].top  + GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT);

    //\̈ݒ
    if (GGAF_PROPERTY(FULL_SCREEN)) {
        //tXN[[h
        if (GGAF_PROPERTY(DUAL_VIEW)) {
            _aRect_ViewScreen[0].top    = 0;
            _aRect_ViewScreen[0].left   = 0;
            _aRect_ViewScreen[0].right  = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH);
            _aRect_ViewScreen[0].bottom = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT);
            _aRect_ViewScreen[1].top    = 0;
            _aRect_ViewScreen[1].left   = 0;
            _aRect_ViewScreen[1].right  = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH);
            _aRect_ViewScreen[1].bottom = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT);

            //tXN[[hEQʎgp
            if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                LONG fix_width = GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
                LONG fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                //utXN[[hEQʎgpEcFIXv̂Pʖڃtgobt@`̈
                if (1.0f * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH) / GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[0].left   = (GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[0].top    = 0;
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[0].left   = 0;
                    _aRect_Present[0].top    = (GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                }

                //utXN[[hEQʎgpEcFIXv̂Qʖڃtgobt@`̈
                if (1.0f * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH) / GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[1].left   = (GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[1].top    = 0;
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[1].left   = 0;
                    _aRect_Present[1].top    = (GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                }
                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION1), _aRect_Present[0],
                                    GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH), GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT));
                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2), _aRect_Present[1],
                                    GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH), GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT));
            } else {
                //utXN[[hEQʎgpEcXgb`v̂Pʖڃtgobt@`̈
                _aRect_Present[0].left   = 0;
                _aRect_Present[0].top    = 0;
                _aRect_Present[0].right  = _aRect_Present[0].left + GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH);
                _aRect_Present[0].bottom = _aRect_Present[0].top  + GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT);
                //utXN[[hEQʎgpEcXgb`v̂Qʖڃtgobt@`̈
                _aRect_Present[1].left   = 0;
                _aRect_Present[1].top    = 0;
                _aRect_Present[1].right  = _aRect_Present[1].left + GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH);
                _aRect_Present[1].bottom = _aRect_Present[1].top  + GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT);
            }
        } else {
            //tXN[[hEPʎgp
            _aRect_ViewScreen[0].top    = 0;
            _aRect_ViewScreen[0].left   = 0;
            _aRect_ViewScreen[0].right  = GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH);
            _aRect_ViewScreen[0].bottom = GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT);
            _aRect_ViewScreen[1] = _aRect_ViewScreen[0];

            if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                LONG fix_width = GGAF_PROPERTY(GAME_BUFFER_WIDTH);
                LONG fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                //utXN[[hEPʎgpEcFIXṽtgobt@`̈
                if (1.0f * GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH) / GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[0].left   = (GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[0].top    = 0;
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[0].left   = 0;
                    _aRect_Present[0].top    = (GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                }
                _aRect_Present[1] = _aRect_Present[0];

                positionPresentRect(GGAF_PROPERTY(SINGLE_VIEW_DRAW_POSITION), _aRect_Present[0],
                                    GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH), GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT));
                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2), _aRect_Present[1],
                                    GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH), GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT));
            } else {
                //utXN[[hEPʎgpEcXgb`ṽtgobt@`̈
                _aRect_Present[0].left   = 0;
                _aRect_Present[0].top    = 0;
                _aRect_Present[0].right  = _aRect_Present[0].left + GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH);
                _aRect_Present[0].bottom = _aRect_Present[0].top  + GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT);
                _aRect_Present[1] = _aRect_Present[0];
            }
        }
    } else {
        //EBhE[h
        if (GGAF_PROPERTY(DUAL_VIEW)) {
            //EBhE[hEQgp
            if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                LONG fix_width = GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
                LONG fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                //uEBhE[hEQgpEcFIXv̂Pڃtgobt@`̈
                if (1.0f * GGAF_PROPERTY(DUAL_VIEW_WINDOW1_WIDTH) / GGAF_PROPERTY(DUAL_VIEW_WINDOW1_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_WINDOW1_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[0].left   = (GGAF_PROPERTY(DUAL_VIEW_WINDOW1_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[0].top    = 0;
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_WINDOW1_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[0].left   = 0;
                    _aRect_Present[0].top    = (GGAF_PROPERTY(DUAL_VIEW_WINDOW1_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                }

                //uEBhE[hEQgpEcFIXv̂Qڃtgobt@`̈
                if (1.0f * GGAF_PROPERTY(DUAL_VIEW_WINDOW2_WIDTH) / GGAF_PROPERTY(DUAL_VIEW_WINDOW2_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_WINDOW2_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[1].left   = (GGAF_PROPERTY(DUAL_VIEW_WINDOW2_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[1].top    = 0;
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(DUAL_VIEW_WINDOW2_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[1].left   = 0;
                    _aRect_Present[1].top    = (GGAF_PROPERTY(DUAL_VIEW_WINDOW2_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                }

                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION1), _aRect_Present[0],
                                    GGAF_PROPERTY(DUAL_VIEW_WINDOW1_WIDTH), GGAF_PROPERTY(DUAL_VIEW_WINDOW1_HEIGHT));
                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2), _aRect_Present[1],
                                    GGAF_PROPERTY(DUAL_VIEW_WINDOW2_WIDTH), GGAF_PROPERTY(DUAL_VIEW_WINDOW2_HEIGHT));
            } else {
                //uEBhE[hEQgpEcXgb`v̂Pڃtgobt@`̈
                _aRect_Present[0].left   = 0;
                _aRect_Present[0].top    = 0;
                _aRect_Present[0].right  = _aRect_Present[0].left + GGAF_PROPERTY(DUAL_VIEW_WINDOW1_WIDTH);
                _aRect_Present[0].bottom = _aRect_Present[0].top  + GGAF_PROPERTY(DUAL_VIEW_WINDOW1_HEIGHT);
                //uEBhE[hEQgpEcXgb`v̂Qڃtgobt@`̈
                _aRect_Present[1].left   = 0;
                _aRect_Present[1].top    = 0;
                _aRect_Present[1].right  = _aRect_Present[1].left + GGAF_PROPERTY(DUAL_VIEW_WINDOW2_WIDTH);
                _aRect_Present[1].bottom = _aRect_Present[1].top  + GGAF_PROPERTY(DUAL_VIEW_WINDOW2_HEIGHT);
            }
        } else {
            //EBhE[hEPgp
            if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                LONG fix_width = GGAF_PROPERTY(GAME_BUFFER_WIDTH);
                LONG fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                //uEBhE[hEPgpEcFIXṽtgobt@`̈
                if (1.0f * GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH) / GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT) > 1.0f * fix_width / fix_height) {
                    //艡ɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT) / fix_height; //k=c̔䗦
                    _aRect_Present[0].left   = (GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH) / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[0].top    = 0;
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                } else {
                    //cɂȂĂ܂Ă
                    double rate = 1.0 * GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH) / fix_width; //k=̔䗦
                    _aRect_Present[0].left   = 0;
                    _aRect_Present[0].top    = (GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT) / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                }
                _aRect_Present[1] = _aRect_Present[0];

                positionPresentRect(GGAF_PROPERTY(SINGLE_VIEW_DRAW_POSITION), _aRect_Present[0],
                                    GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH), GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT));
                positionPresentRect(GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2), _aRect_Present[1],
                                    GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH), GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT));
            } else {
                //uEBhE[hEPgpEcXgb`ṽtgobt@`̈
                _aRect_Present[0].left   = 0;
                _aRect_Present[0].top    = 0;
                _aRect_Present[0].right  = _aRect_Present[0].left + GGAF_PROPERTY(SINGLE_VIEW_WINDOW_WIDTH);
                _aRect_Present[0].bottom = _aRect_Present[0].top  + GGAF_PROPERTY(SINGLE_VIEW_WINDOW_HEIGHT);
                _aRect_Present[1] = _aRect_Present[0];
            }
        }
    }
    _TRACE_(" _aRect_Present[0].left   = "<<_aRect_Present[0].left  );
    _TRACE_(" _aRect_Present[0].top    = "<<_aRect_Present[0].top   );
    _TRACE_(" _aRect_Present[0].right  = "<<_aRect_Present[0].right );
    _TRACE_(" _aRect_Present[0].bottom = "<<_aRect_Present[0].bottom);
    _TRACE_(" _aRect_Present[1].left   = "<<_aRect_Present[1].left  );
    _TRACE_(" _aRect_Present[1].top    = "<<_aRect_Present[1].top   );
    _TRACE_(" _aRect_Present[1].right  = "<<_aRect_Present[1].right );
    _TRACE_(" _aRect_Present[1].bottom = "<<_aRect_Present[1].bottom);
}

HRESULT GgafDxGod::init() {
    //2011/09/18 WDDM gpłȂgp悤ɕύXB
    // }`j^tXN[̃foCXXg̕A
    // XPł͂܂̂Vistał͂܂Ȃ邱ƂoB
    // IDirect3D9Ex ݂̑CɂȂAɎB
    // WDDM܂ IDirect3D9Ex or IDirect3D9 ̑IsB
    // IDirect3D9Ex 擾 Direct3DCreate9Ex() gpA
    // ߂ľʂŔ肷ΗǂƈՂɍlĂA
    // IDirect3D9Ex ̎ԂAVista ȍ~  d3d9.dll ɂ̂ݑ݂炵A
    // Direct3DCreate9Ex() ֐̃R[h_ŁAXP̏ꍇ d3d9.dll [h
    // uGg|Cg܂vƂG[ɂȂĂ܂słȂB
    // R[h𗼑Ήɂ́ADirect3DCreate9Ex() ͎gȂƎvB
    // ňȉ̂悤 d3d9.dll ADirect3DCreate9Ex 𒼐ڒTāA|C^
    // 擾@MSDNɂ̂ŁAQlɂĎB
    // __uuid Zq GCC ɂ͖̂ŁAIDD_IDirect3D9 ɕύXB
    // TODO::ŐȂ̂낤cB

    HRESULT hr;
    typedef HRESULT (WINAPI *DIRECT3DCREATE9EXFUNCTION)(UINT SDKVersion, IDirect3D9Ex**);
    IDirect3D9* pID3D9 = NULL;
    IDirect3D9Ex* pID3D9Ex = NULL;
    HMODULE hD3D = LoadLibrary(TEXT("d3d9.dll"));

    DIRECT3DCREATE9EXFUNCTION pFunc_Direct3DCreate9Ex = (DIRECT3DCREATE9EXFUNCTION)GetProcAddress(hD3D, "Direct3DCreate9Ex");
    if (pFunc_Direct3DCreate9Ex) {
        //d3d9.dll  Direct3DCreate9Ex ݂͑B
        hr = ((*pFunc_Direct3DCreate9Ex)(D3D_SDK_VERSION, &pID3D9Ex)); //Direct3DCreate9Ex s
        if (FAILED(hr)) {
            MessageBox(GgafDxGod::_pHWndPrimary, TEXT("IDirect3D9Ex R|[lg擾Ɏs܂B(1)"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
            FreeLibrary(hD3D);
            return E_FAIL; //s
        }
//        hr = pID3D9Ex->QueryInterface(IID_IDirect3D9, reinterpret_cast<void **>(&pID3D9)); //COMƂĎgp
//        if (FAILED(hr)) {
//            MessageBox(GgafDxGod::_pHWndPrimary, TEXT("IDirect3D9Ex R|[lg擾Ɏs܂B(2)"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
//            FreeLibrary(hD3D);
//            return E_FAIL; //s
//        }
        GgafDxGod::_pID3D9 = (IDirect3D9*)pID3D9Ex;
        _can_wddm = true;
    } else {
        //d3d9.dll  Direct3DCreate9Ex ݂͑ȂB
        pID3D9 = Direct3DCreate9(D3D_SDK_VERSION);
        if (!pID3D9) {
            MessageBox(GgafDxGod::_pHWndPrimary, TEXT("IDirect3D9 R|[lg擾Ɏs܂B"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
            FreeLibrary(hD3D);
            return E_FAIL; //s
        }
        GgafDxGod::_pID3D9 = pID3D9;
        _can_wddm = false;
    }
    FreeLibrary(hD3D);

    //foCXp[^쐬
    _paPresetPrm = NEW D3DPRESENT_PARAMETERS[2];
    ZeroMemory(&_paPresetPrm[0], sizeof(D3DPRESENT_PARAMETERS));

    //EBhEEtXN[
    _paPresetPrm[0].BackBufferCount        = 1;            //obNobt@̐
    _paPresetPrm[0].EnableAutoDepthStencil = TRUE;         //obNobt@ Zobt@̎쐬
    _paPresetPrm[0].AutoDepthStencilFormat = D3DFMT_D24S8; //[xXeVobt@ //D3DFMT_D16;
    _paPresetPrm[0].Flags                  = 0;            //0ɂĂ

    if (GGAF_PROPERTY(FULL_SCREEN)) {

        //tXN[
        _paPresetPrm[0].BackBufferFormat           = D3DFMT_X8R8G8B8; //D3DFMT_A8R8G8B8; //D3DFMT_X8R8G8B8; //D3DFMT_R5G6B5;
        _paPresetPrm[0].Windowed                   = false; //tXN[[h
        _paPresetPrm[0].FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT; //tbV[g
        _paPresetPrm[0].PresentationInterval       = D3DPRESENT_INTERVAL_DEFAULT; //Xbṽ^C~O
        _paPresetPrm[0].SwapEffect                 = D3DSWAPEFFECT_DISCARD;

        if(GGAF_PROPERTY(DUAL_VIEW)) {
            _paPresetPrm[1] = _paPresetPrm[0]; //RR܂ł𕡐

            _paPresetPrm[0].EnableAutoDepthStencil = FALSE;   //Zobt@̎쐬
            _paPresetPrm[1].EnableAutoDepthStencil = FALSE;
            //yz
            //EnableAutoDepthStencil = FALSE;
            //ƂƁA_OXe[g D3DRS_ZENABLE  FALSE ɂȂ邾̂悤ɌB
            //]āuvɂłAugpsvł͂Ȃ̂낤EEEB
        } else {
            _paPresetPrm[0].EnableAutoDepthStencil = FALSE; //Z obt@̎쐬L
        }
    } else {
        //EBhE
        _paPresetPrm[0].BackBufferFormat           = D3DFMT_UNKNOWN; //݂̕\[htH[}bg
        _paPresetPrm[0].Windowed                   = true; //EBhE[h
        _paPresetPrm[0].FullScreen_RefreshRateInHz = 0; //tbV[g
        _paPresetPrm[0].PresentationInterval       = D3DPRESENT_INTERVAL_IMMEDIATE; //
        _paPresetPrm[0].SwapEffect                 = D3DSWAPEFFECT_COPY; //TODO:Window[h͂Ȃ̂HAD3DPRESENT_INTERVAL_ONE Ƃ߂H

        if(GGAF_PROPERTY(DUAL_VIEW)) {
            _paPresetPrm[1] = _paPresetPrm[0]; //RR܂ł𕡐
            _paPresetPrm[0].EnableAutoDepthStencil = TRUE; //Z obt@̎쐬
            _paPresetPrm[1].EnableAutoDepthStencil = TRUE;
        } else {

            _paPresetPrm[0].EnableAutoDepthStencil = TRUE; //Z obt@̎쐬
        }


//        //fXvC[h̎擾
//        D3DDISPLAYMODE structD3DDisplayMode0; //ʂi[\
//        hr = GgafDxGod::_pID3D9->GetAdapterDisplayMode(0, &structD3DDisplayMode0);
//        returnWhenFailed(hr, D3D_OK, "GetAdapterDisplayMode Ɏs܂B");
//        if(GGAF_PROPERTY(DUAL_VIEW)) {
//            D3DDISPLAYMODE structD3DDisplayMode1;
//            hr = GgafDxGod::_pID3D9->GetAdapterDisplayMode(1, &structD3DDisplayMode1);
//            returnWhenFailed(hr, D3D_OK, "2ʖ GetAdapterDisplayMode Ɏs܂");
//            _paPresetPrm[0].BackBufferFormat = structD3DDisplayMode0.Format; //݂̉ʃ[h𗘗p
//            _paPresetPrm[1].BackBufferFormat = structD3DDisplayMode1.Format; //݂̉ʃ[h𗘗p
//        } else {
//            _paPresetPrm[0].BackBufferFormat = structD3DDisplayMode0.Format; //݂̉ʃ[h𗘗p
//            _paPresetPrm[1].BackBufferFormat = D3DFMT_UNKNOWN; //݂̉ʃ[h𗘗p
//        }
    }

    //A`ACAXɂł邩`FbN
    DWORD qualityLevels = D3DMULTISAMPLE_NONE;
    D3DMULTISAMPLE_TYPE multiSampleType = D3DMULTISAMPLE_NONE;
//    if( SUCCEEDED(GgafDxGod::_pID3D9->CheckDeviceMultiSampleType(
//        D3DADAPTER_DEFAULT,
//        D3DDEVTYPE_HAL,
//        _paPresetPrm[0].BackBufferFormat,  //TODO:EBhE[h
//        GGAF_PROPERTY(FULL_SCREEN) ? FALSE : TRUE,
//        D3DMULTISAMPLE_2_SAMPLES,
//        &qualityLevels) ) )
//    {
//        if( SUCCEEDED(GgafDxGod::_pID3D9->CheckDeviceMultiSampleType(
//            D3DADAPTER_DEFAULT,
//            D3DDEVTYPE_HAL,
//            _paPresetPrm[0].AutoDepthStencilFormat,
//            GGAF_PROPERTY(FULL_SCREEN) ? FALSE : TRUE,
//            D3DMULTISAMPLE_2_SAMPLES,
//            NULL) ) )
//        {
//            multiSampleType = D3DMULTISAMPLE_2_SAMPLES;
//            _TRACE_("n[hEFA MultiSampleType = D3DMULTISAMPLE_2_SAMPLES LII");
//        } else {
//            multiSampleType = D3DMULTISAMPLE_NONE;
//            qualityLevels = D3DMULTISAMPLE_NONE;
//        }
//    } else {
//        multiSampleType = D3DMULTISAMPLE_NONE;
//        qualityLevels = D3DMULTISAMPLE_NONE;
//    }

    if(GGAF_PROPERTY(DUAL_VIEW)) {
        //}`Tv̐
        _paPresetPrm[0].MultiSampleType = multiSampleType;//D3DMULTISAMPLE_NONE; D3DMULTISAMPLE_2_SAMPLES
        //}`Tv̕ix
        _paPresetPrm[0].MultiSampleQuality = qualityLevels - (qualityLevels > 0 ? 1 : 0);
        //}`Tv̐
        _paPresetPrm[1].MultiSampleType = multiSampleType;//D3DMULTISAMPLE_NONE;
        //}`Tv̕ix
        _paPresetPrm[1].MultiSampleQuality = qualityLevels - (qualityLevels > 0 ? 1 : 0);
    } else {
        //}`Tv̐
        _paPresetPrm[0].MultiSampleType = multiSampleType;//D3DMULTISAMPLE_NONE;
        //}`Tv̕ix
        _paPresetPrm[0].MultiSampleQuality = qualityLevels - (qualityLevels > 0 ? 1 : 0);
    }

//    //}`Tv̐
//    _paPresetPrm[0].MultiSampleType = multiSampleType;//D3DMULTISAMPLE_NONE;
//    //}`Tv̕ix
//    _paPresetPrm[0].MultiSampleQuality = 0;//qualityLevels - (qualityLevels > 0 ? 1 : 0);





    //Windownhʎw
    _paPresetPrm[0].hDeviceWindow = _pHWndPrimary;
    _paPresetPrm[1].hDeviceWindow = _pHWndSecondary;
    //obNobt@TCY
    if (GGAF_PROPERTY(FULL_SCREEN)) {
        if(GGAF_PROPERTY(DUAL_VIEW)) {
            //tXN[[hEQʎgp
            _paPresetPrm[0].BackBufferWidth  = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_WIDTH);
            _paPresetPrm[0].BackBufferHeight = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN1_HEIGHT);
            _paPresetPrm[1].BackBufferWidth  = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_WIDTH);
            _paPresetPrm[1].BackBufferHeight = GGAF_PROPERTY(DUAL_VIEW_FULL_SCREEN2_HEIGHT);
        } else {
            //tXN[[hEPʎgp
            _paPresetPrm[0].BackBufferWidth  = GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_WIDTH);
            _paPresetPrm[0].BackBufferHeight = GGAF_PROPERTY(SINGLE_VIEW_FULL_SCREEN_HEIGHT);
            _paPresetPrm[1].BackBufferWidth  = 0;
            _paPresetPrm[1].BackBufferHeight = 0;
        }
    } else {
        if(GGAF_PROPERTY(DUAL_VIEW)) {
            //EBhE[hEQʎgp
            _paPresetPrm[0].BackBufferWidth  = GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH);
            _paPresetPrm[0].BackBufferHeight = GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT);
            _paPresetPrm[1].BackBufferWidth  = 0;
            _paPresetPrm[1].BackBufferHeight = 0;
        } else {
            //EBhE[hEPʎgp
            _paPresetPrm[0].BackBufferWidth  = GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH);
            _paPresetPrm[0].BackBufferHeight = GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT);
            _paPresetPrm[1].BackBufferWidth  = 0;
            _paPresetPrm[1].BackBufferHeight = 0;
        }
    }

    _paDisplayMode = NEW D3DDISPLAYMODEEX[2];
    _paDisplayMode[0].Size = sizeof(_paDisplayMode[0]);
    _paDisplayMode[0].Width = _paPresetPrm[0].BackBufferWidth;
    _paDisplayMode[0].Height = _paPresetPrm[0].BackBufferHeight;
    _paDisplayMode[0].Format = _paPresetPrm[0].BackBufferFormat;
    _paDisplayMode[0].RefreshRate = _paPresetPrm[0].FullScreen_RefreshRateInHz;
    _paDisplayMode[0].ScanLineOrdering = D3DSCANLINEORDERING_PROGRESSIVE;

    _paDisplayMode[1].Size = sizeof(_paDisplayMode[1]);
    _paDisplayMode[1].Width = _paPresetPrm[1].BackBufferWidth;
    _paDisplayMode[1].Height = _paPresetPrm[1].BackBufferHeight;
    _paDisplayMode[1].Format = _paPresetPrm[1].BackBufferFormat;
    _paDisplayMode[1].RefreshRate = _paPresetPrm[1].FullScreen_RefreshRateInHz;
    _paDisplayMode[1].ScanLineOrdering = D3DSCANLINEORDERING_PROGRESSIVE;

    //tXN[ɏo邩ׂ
    D3DCAPS9 caps;
    GgafDxGod::_pID3D9->GetDeviceCaps(D3DADAPTER_DEFAULT, // [in] fBXvC A_v^B
                                       D3DDEVTYPE_HAL,     // [in] foCX̎ށB D3DDEVTYPE񋓌^̃o
                                       &caps);             // [out] foCX̔\͂i[

    _num_adapter = caps.NumberOfAdaptersInGroup;   //gA_v^̐擾
    _TRACE_("_num_adapter = "<< _num_adapter);
    if (GGAF_PROPERTY(FULL_SCREEN)) {
        for (int disp_no = 0; disp_no <= (GGAF_PROPERTY(DUAL_VIEW) ? 1 : 0); disp_no++) {
            int mode_num = GgafDxGod::_pID3D9->GetAdapterModeCount(disp_no,
                                                                    _paPresetPrm[0].BackBufferFormat);
            if (mode_num) {
                D3DDISPLAYMODE adp;
                for (int i = 0; i < mode_num; i++) {
                    GgafDxGod::_pID3D9->EnumAdapterModes(disp_no,
                                                          _paPresetPrm[0].BackBufferFormat, i, &adp);
                    _TRACE_("["<<disp_no<<"]"<<adp.Width<<"x"<<adp.Height);
                    if (adp.Format == _paPresetPrm[disp_no].BackBufferFormat &&
                        adp.Width  == _paPresetPrm[disp_no].BackBufferWidth  &&
                        adp.Height == _paPresetPrm[disp_no].BackBufferHeight ) {
                        //OK
                        _TRACE_("BINGO!");
                        break;
                    }
                    if (mode_num-1 == i) {
                        //vg𑜓xȂ
                        std::stringstream ss;
                        if (GGAF_PROPERTY(DUAL_VIEW)) {
                            ss << _paPresetPrm[disp_no].BackBufferWidth<<"x"<<_paPresetPrm[disp_no].BackBufferHeight<<" tXN[[hɂ鎖ł܂B\n"<<
                                   (disp_no+1)<<"ʖڂ̉𑜓x̐ݒmFĂB";
                        } else {
                            ss << _paPresetPrm[disp_no].BackBufferWidth<<"x"<<_paPresetPrm[disp_no].BackBufferHeight<<" tXN[[hɂ鎖ł܂B\n"<<
                                    "𑜓x̐ݒmFĂB";
                        }
                        MessageBox(GgafDxGod::_pHWndPrimary, TEXT(ss.str().c_str()), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
                        return E_FAIL;
                    }
                }
            } else {
                MessageBox(GgafDxGod::_pHWndPrimary, TEXT("tXN[[h\ȉ𑜓x񂪎擾ł܂łB\ngp̃rfIJ[hł̓vOsł܂B"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
                return E_FAIL;
            }
        }
    }

    //sNZVF[_[A_VF[_[o[W`FbN
    _vs_v = caps.VertexShaderVersion;
    _ps_v = caps.PixelShaderVersion;
    _TRACE_("Hardware Vertex Shader Version = "<<D3DSHADER_VERSION_MAJOR(_vs_v)<<"_"<<D3DSHADER_VERSION_MINOR(_vs_v));
    _TRACE_("Hardware Pixel Shader Version  = "<<D3DSHADER_VERSION_MAJOR(_ps_v)<<"_"<<D3DSHADER_VERSION_MINOR(_ps_v));
    if (_vs_v < D3DVS_VERSION(2, 0) || _ps_v < D3DPS_VERSION(2, 0)) {
        _TRACE_("rfIJ[hn[h̒_VF[_[ƃsNZVF[_[́AɃo[W 2_0 ȏオłB");
        _TRACE_("gp̃rfIJ[hł́A삵Ȃꂪ܂B");
    }

//    //default
//    UINT AdapterToUse = D3DADAPTER_DEFAULT;
//    D3DDEVTYPE DeviceType = D3DDEVTYPE_HAL;
//    // NVIDIA PerfHUD p begin --------------------------------------------->

//#ifdef MY_DEBUG
//
//#if SHIPPING_VERSION
//    // When building a shipping version, disable PerfHUD (opt-out)
//#else
//    _TRACE_("Look for 'NVIDIA PerfHUD' adapter...");
//    // If it is present, override default settings
//    for (UINT Adapter = 0; Adapter < GgafDxGod::_pID3D9->GetAdapterCount(); Adapter++) {
//        D3DADAPTER_IDENTIFIER9 Identifier;
//        HRESULT Res;
//        Res = GgafDxGod::_pID3D9->GetAdapterIdentifier(Adapter, 0, &Identifier);
//        if (strstr(Identifier.Description, "PerfHUD") != 0) {
//            _TRACE_("found NVIDIA PerfHUD!");
//            AdapterToUse = Adapter;
//            DeviceType = D3DDEVTYPE_REF;
//            break;
//        }
//    }
//#endif
//
//#endif
    // <------------------------------------------------ NVIDIA PerfHUD p end


    if (GGAF_PROPERTY(FULL_SCREEN) && GGAF_PROPERTY(DUAL_VIEW)) {
        //tXN[  fAr[ ̏ꍇ
        //foCX쐬 GgafDxGod::_pID3DDevice9 ֐ݒ肷B
        //n[hEFAɂ钸_AX^CYsfoCX쐬݂BHAL(pure vp)
        hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GgafDxGod::_pHWndPrimary,
                             D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE | D3DCREATE_ADAPTERGROUP_DEVICE,
                             _paPresetPrm, _paDisplayMode);
        if (hr != D3D_OK) {
            _TRACE_("}`wbhD3DCREATE_HARDWARE_VERTEXPROCESSING : "<<GgafDxCriticalException::getHresultMsg(hr));

            //\tgEFAɂ钸_An[hEFAɂ郉X^CYsfoCX쐬݂BHAL(soft vp)
            hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GgafDxGod::_pHWndPrimary,
                                 D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE | D3DCREATE_ADAPTERGROUP_DEVICE,
                                 _paPresetPrm, _paDisplayMode);
            if (hr != D3D_OK) {
                _TRACE_("}`wbhD3DCREATE_HARDWARE_VERTEXPROCESSING : "<<GgafDxCriticalException::getHresultMsg(hr));

                //\tgEFAɂ钸_AX^CYsfoCX쐬݂BREF
                hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, GgafDxGod::_pHWndPrimary,
                                     D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE | D3DCREATE_ADAPTERGROUP_DEVICE,
                                     _paPresetPrm, _paDisplayMode);
                if (hr != D3D_OK) {
                    _TRACE_("}`wbhD3DCREATE_SOFTWARE_VERTEXPROCESSING : "<<GgafDxCriticalException::getHresultMsg(hr));

                    //ǂ̃foCX̍쐬sꍇ
                    MessageBox(GgafDxGod::_pHWndPrimary, TEXT("DirectX̏Ɏs܂B\n}`wbhfBXvC݂Ă܂B"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
                    return E_FAIL;
                } else {
                    _TRACE_("GgafDxGod::init foCX MULTI FULLSCRREEN REF ŏł܂B");
                }

            } else {
                _TRACE_("GgafDxGod::init foCX MULTI FULLSCRREEN HAL(soft vp) ŏł܂B");
            }

        } else {
            _TRACE_("GgafDxGod::init foCX MULTI FULLSCRREEN HAL(pure vp) ŏł܂B");
        }

    } else {
        //(tXN[  fAr[) ȊȌꍇ
        //foCX쐬 GgafDxGod::_pID3DDevice9 ֐ݒ肷B
        //n[hEFAɂ钸_AX^CYsfoCX쐬݂BHAL(pure vp)
        hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GgafDxGod::_pHWndPrimary,
                             D3DCREATE_PUREDEVICE | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE,
                             &_paPresetPrm[0], &_paDisplayMode[0]);
//                                           D3DCREATE_MIXED_VERTEXPROCESSING|D3DCREATE_MULTITHREADED,
//                                           D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED,
        if (hr != D3D_OK) {
            //\tgEFAɂ钸_An[hEFAɂ郉X^CYsfoCX쐬݂BHAL(soft vp)
            hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GgafDxGod::_pHWndPrimary,
                                 D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE,
                                 &_paPresetPrm[0], &_paDisplayMode[0]);
            if (hr != D3D_OK) {
                //\tgEFAɂ钸_AX^CYsfoCX쐬݂BREF
                hr = createDx9Device(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, GgafDxGod::_pHWndPrimary,
                                     D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED | D3DCREATE_FPU_PRESERVE,
                                     &_paPresetPrm[0], &_paDisplayMode[0]);
                if (hr != D3D_OK) {
                    //ǂ̃foCX̍쐬sꍇ
                    MessageBox(GgafDxGod::_pHWndPrimary, TEXT("DirectX̏Ɏs܂B"), TEXT("ERROR"), MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
                    return E_FAIL;
                } else {
                    _TRACE_("GgafDxGod::init foCX REF ŏł܂B");
                }

            } else {
                _TRACE_("GgafDxGod::init foCX HAL(soft vp) ŏł܂B");
            }

        } else {
            _TRACE_("GgafDxGod::init foCX HAL(pure vp) ŏł܂B");
        }
    }

    //̑Kvȏ
    _pCubeMapTextureManager = NEW GgafDxTextureManager("CMTexManager");
    _pModelManager = NEW GgafDxModelManager("ModelManager");
    _pEffectManager = NEW GgafDxEffectManager("EffectManager");
    GgafDxUtil::init();  //[eBeB
    GgafDxInput::init(); //DirectInput
    GgafDxSound::init(); //DirectSound

    //foCX
    hr = initDx9Device();
    if (hr == E_FAIL) {
        return E_FAIL;
    }
    Sleep(1000);
    //tXN[A_O^[QbgeNX`[쐬
    if (GGAF_PROPERTY(FULL_SCREEN)) {
        hr = restoreFullScreenRenderTarget();
        if (hr == E_FAIL) {
            return E_FAIL;
        }
    }

    //2011/09/28
    //TODO:VISTAłQʃtXN[ANbNŃtXN[̑΍
    //WDDMŃfoCX쐬AQʃtXN[ŋNAQʖڂ̗̈̂A
    //ƂƂ̂Pʖڂ̈(𑜓xύXɂQʖڂւ͂ݏoojNbNƁA
    //tXN[Ă܂ƂCɂȂBȂ̎Ԃ₵A@͌ȂB
    //AŃEBhEč\z邱ƂŁAȂ͉łB
    //ԂAK̕@ȂB̍EEEB
    if (_can_wddm && GGAF_PROPERTY(FULL_SCREEN) && GGAF_PROPERTY(DUAL_VIEW)) {
        hr = releaseFullScreenRenderTarget();
        hr = restoreFullScreenRenderTarget();
    }
    return D3D_OK;
}

BOOL CALLBACK GgafDxGod::getSecondaryMoniterPixcoordCallback(HMONITOR hMonitor,
                                                             HDC hdcMonitor,
                                                             LPRECT lprcMonitor,
                                                             LPARAM dwData) {
    GgafDxGod* pGod = (GgafDxGod*)dwData;
    MONITORINFOEX moniter_info;
    moniter_info.cbSize = sizeof(MONITORINFOEX);
    GetMonitorInfo(hMonitor, &moniter_info);
    if (moniter_info.dwFlags != MONITORINFOF_PRIMARY) {
        //vC}j^ł͖AăZJ_ƌȂ(G)EEE
        //Qʖڂ̍Wۑ
        pGod->_secondary_screen_x = moniter_info.rcMonitor.left;
        pGod->_secondary_screen_y = moniter_info.rcMonitor.top;
    }
    return TRUE;
}

HRESULT GgafDxGod::createDx9Device(UINT Adapter,
                                   D3DDEVTYPE DeviceType,
                                   HWND hFocusWindow,
                                   DWORD BehaviorFlags,
                                   D3DPRESENT_PARAMETERS* pPresentationParameters,
                                   D3DDISPLAYMODEEX* pFullscreenDisplayMode
                                  ) {
    HRESULT hr;
    if (_can_wddm) {
        if (!GGAF_PROPERTY(FULL_SCREEN)) {
            pFullscreenDisplayMode = NULL;
        }
        IDirect3D9Ex* pID3D9Ex = (IDirect3D9Ex*)GgafDxGod::_pID3D9;
        IDirect3DDevice9Ex* pID3DDevice9Ex;
        hr = pID3D9Ex->CreateDeviceEx(Adapter,
                                      DeviceType,
                                      hFocusWindow,
                                      BehaviorFlags,
                                      pPresentationParameters,
                                      pFullscreenDisplayMode,
                                      &pID3DDevice9Ex
                                      );
        GgafDxGod::_pID3DDevice9 = (IDirect3DDevice9Ex*)pID3DDevice9Ex;
    } else {
        hr = GgafDxGod::_pID3D9->CreateDevice(Adapter,
                                              DeviceType,
                                              hFocusWindow,
                                              BehaviorFlags,
                                              pPresentationParameters,
                                              &GgafDxGod::_pID3DDevice9
                                              );
    }
    return hr;
 }

HRESULT GgafDxGod::initDx9Device() {
    // ftHg̃Cg
    /*
     ZeroMemory(&_d3dlight9_default, sizeof(D3DLIGHT9) );
     GgafDxGod::_d3dlight9_default.Type = D3DLIGHT_DIRECTIONAL; //sAFƕł悢
     GgafDxGod::_d3dlight9_default.Direction = D3DXVECTOR3(-1.0f, -1.0f, 1.0f);
     GgafDxGod::_d3dlight9_default.Diffuse = D3DXCOLOR(1.0f, 1.0f, 1.0f, 0.0f);
     GgafDxGod::_d3dlight9_default.Ambient = D3DXCOLOR(1.0f, 1.0f, 1.0f, 0.0f);
     //͕sł͊֌WȂ
     //GgafDxGod::_d3dlight9_default.Position = D3DXVECTOR3(-1*GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2, -1*GGAF_PROPERTY(GAME_BUFFER_HEIGHT)/2, -1*GGAF_PROPERTY(GAME_BUFFER_HEIGHT)/2);
     //GgafDxGod::_d3dlight9_default.Range = 1000;
     */

    //Cg\̂́AVF[_[̃p[^ɂȂ鎞邽ߕKvB
    D3DXVECTOR3 vecDirection(-1.0f, -1.0f, 1.0f);
    D3DXVec3Normalize(&vecDirection, &vecDirection);
    ZeroMemory(&_d3dlight9_default, sizeof(D3DLIGHT9));
    GgafDxGod::_d3dlight9_default.Direction = vecDirection;
    GgafDxGod::_d3dlight9_default.Type = D3DLIGHT_DIRECTIONAL;
    GgafDxGod::_d3dlight9_default.Diffuse.a = 1.0f;
    GgafDxGod::_d3dlight9_default.Diffuse.r = 1.0f;
    GgafDxGod::_d3dlight9_default.Diffuse.g = 1.0f;
    GgafDxGod::_d3dlight9_default.Diffuse.b = 1.0f;

    GgafDxGod::_d3dlight9_default.Ambient.a = 1.0f;
    GgafDxGod::_d3dlight9_default.Ambient.r = 0.3f; //ArGgCgSetRenderState(D3DRS_AMBIENT, 0x00303030)Őݒ
    GgafDxGod::_d3dlight9_default.Ambient.g = 0.3f;
    GgafDxGod::_d3dlight9_default.Ambient.b = 0.3f;

    //GgafDxGod::_d3dlight9_default.Range = 1000.0f;


    //CgZbg
    //    GgafDxGod::_pID3DDevice9->SetLight(0, &GgafDxGod::_d3dlight9_default);
    //CgXCb`ON
    //    GgafDxGod::_pID3DDevice9->LightEnable(0, TRUE);
    //GgafDxGod::_pID3DDevice9->LightEnable(0, FALSE);
    //_ɃCg̉eiAejL
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_LIGHTING, TRUE);
    //_ɃCg̉eiAej𖳌 (sNZVF[_[ōsȂ߁j
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_LIGHTING, FALSE);
    //_AEɋʂ̃ArGgCgLɂ悤ɕ`
    //   GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_AMBIENT, _dwAmbientBrightness_default);

    // Zobt@L
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
    // Zobt@𖳌
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZENABLE, D3DZB_FALSE);
    //Zobt@݉
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZWRITEENABLE, TRUE);
    //Zobt@ݕs
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZWRITEENABLE, FALSE );

    //D3DRENDERSTATE_ZFUNC

    //XeVeXg̕@
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_STENCILFUNC, D3DCMP_ALWAYS); //ɃeXgpX
    //ɎsɃXeV̒lǂω邩
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_STENCILFAIL, D3DSTENCILOP_KEEP); //ωȂ
    //ZeXgŎsꍇ̃XeVl̕ω
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP); //ωȂ


    //ivjɃJO 捶Wn
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
    //JOȂ
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

    // fBUO
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_DITHERENABLE, TRUE );
    // }`TvOA`GCAX(ƂĂtXN[H)TODO:܂
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, TRUE);
//    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_MULTISAMPLEMASK, 0x00ffffff);

    //sNZPʂ̃At@eXgL
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

    //ݒ̓VF[_[ɏɂ̂ŃRg
    // At@uhnm
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
    //2iKځAeNX`\t|SƃobNobt@i_[^[QbgjƂ̍
    //F̎Zo@̐ݒ
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_BLENDOPALPHA, D3DBLENDOP_ADD); //D3DBLENDOP_ADD=]ɓ]悪Z
    //W
    //    //ɏ摜̍@(VF[_[ɉe)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA); //SRC,D3DBLEND_SRCALPHA=ʂɕ`B|S̃At@l̔Zŕ`BAt@l̒l΍قǁAZ`B
    //    //n̉摜̍@(VF[_[ɉe)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); //DIST,D3DBLEND_INVSRCALPHA=ɕ`|S̃At@l̔ZɂāAn̕`𔖂B



    //_J[𖳌ɂ
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_COLORVERTEX, FALSE );
    // GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_COLORVERTEX, TRUE );
    //    //ʂ̃ArGg˂́A}eAQƂ悤ɐݒ肷Bi_J[QƂꍇ D3DMCS_COLOR1)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_AMBIENTMATERIALSOURCE, D3DMCS_MATERIAL);
    //    //ʂ̃ft[Y˂́A}eAQƂ悤ɐݒ肷Bi_J[QƂꍇ D3DMCS_COLOR1)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL);
    //    //ʂ̃G~bVu˂́A}eAQƂݒ肷Bi_J[QƂꍇ D3DMCS_COLOR1)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_EMISSIVEMATERIALSOURCE, D3DMCS_MATERIAL);
    //    //ʂ̃XyL˂́A}eAQƂݒ肷Bi_J[QƂꍇ D3DMCS_COLOR1)
    //    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);

    //_gpƂ
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE , D3DMCS_COLOR1);

    //
    //
    // A`GCAX̎w
    //GgafDxGod::_pID3DDevice9->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
    //GgafDxGod::_pID3DDevice9->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
    //  TypeD3DSAMP_MINFILTER/D3DSAMP_MAGFILTERig/kj ??D3DTSS_MAGFILTER
    //  ValueD3DTEXTUREFILTERTYPE񋓌^w肷
    //  D3DTEXF_POINT@@@@FtB^ȂB`ł
    //  D3DTEXF_LINEAR@@@FjAtB^i`⊮j
    //  D3DTEXF_ANISOTROPIC@FٕtB^Bn\ʂȂǂ́AgkOƉňقȂꍇɎg
    //  D3DTEXF_PYRAMIDALQUADFegtB^BjAtB^Ƃ܂ςȂ炵
    //  D3DTEXF_GAUSSIANQUAD FKEVAtB^B܂̖ڂtB^
    //  w肷B

    //2009/3/4 SetSamplerStatëӖ뗝B
    //SetSamplerState̓eNX`ǂTvOiǂݎ邩j邩̐ݒB
    //A`GCAXĂĂAeNX`A`GCAX܂B
    //sNZVF[_[őŜŁÂ̐ݒ́ASȂȂ͂B


    //A`GCAXɂ郌_OXe[g
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS,TRUE);
    //GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_MULTISAMPLEMASK,0x7fffffff);

    //FSăVF[_[ŏɂȂ̂ŃRg
    //SetTextureStageState͔p~H
    //  1iKڃ|SƃeNX`̍@ݒ
    //    //eNX`[̐FƁA_J[DIFFUSEFZ悤ɐݒ
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
    //    //eNX`[̃ƁA_J[̃Z悤ɐݒ
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
    //    GgafDxGod::_pID3DDevice9->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);


    //GgafDxCameraֈړ
    // VIEWϊiJʒujݒ
    //D3DXMATRIX _matView; // r[ϊs
    //    DELETE_POSSIBLE_NULL(_pVecCamFromPoint);
    //    DELETE_POSSIBLE_NULL(_pVecCamLookatPoint);
    //    DELETE_POSSIBLE_NULL(_pVecCamUp);

    //GgafDxCameraֈړ
    // ˉeϊiRcʁj
    //D3DXMATRIX _matProj; // ˉeϊs
    //GgafDxGod::_pID3DDevice9->SetTransform(D3DTS_PROJECTION, &_matProj);
    HRESULT hr;
    //obNobt@EBhEBGFŃNA
    //łRenderTarget͂܂Aʏ̃obNobt@ł
    hr = GgafDxGod::_pID3DDevice9->Clear(0, NULL, D3DCLEAR_TARGET, _color_border, 1.0f, 0);
    returnWhenFailed(hr, D3D_OK, "wiF(_color_border)̓hԂAʃNAɎs܂B");
    return D3D_OK;
}


HRESULT GgafDxGod::restoreFullScreenRenderTarget() {
    if (!GGAF_PROPERTY(FULL_SCREEN)) {
        _TRACE_("GgafDxGod::restoreFullScreenRenderTarget() xtXN[ӊOAĂяosvłB");
        return D3D_OK;
    }
    HRESULT hr;
    //`ƂȂeNX`ʓr쐬iobNobt@IȎgpsj
    hr = GgafDxGod::_pID3DDevice9->CreateTexture(
                                        GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH),
                                        GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT),
                                        1, //MipLevel Mip
                                        D3DUSAGE_RENDERTARGET,
                                        _paPresetPrm[0].BackBufferFormat,
                                        D3DPOOL_DEFAULT,
                                        &_pRenderTexture,
                                        NULL);

//    LPDIRECT3DTEXTURE9 pIDirect3DTexture9;
//    HRESULT hr = D3DXCreateTextureFromFileEx(
//                     GgafDxGod::_pID3DDevice9,  // [in] LPDIRECT3DDEVICE9 pDevice,
//                     texture_file_name.c_str(), // [in] LPCTSTR pSrcFile,
//                     D3DX_DEFAULT,              // [in] UINT Widths,
//                     D3DX_DEFAULT,              // [in] UINT Height,
//                     D3DX_DEFAULT,              // [in] UINT MipLevels,  //D3DX_DEFAULT,
//                     0,                         // [in] DWORD Usage,
//                     D3DFMT_UNKNOWN,            // [in] D3DFORMAT Format,
//                     D3DPOOL_DEFAULT,           // [in] D3DPOOL Pool, //D3DPOOL_DEFAULT
//                     D3DX_FILTER_POINT,         // [in] DWORD Filter, D3DX_FILTER_POINTŃ{PiC. D3DX_FILTER_LINEAR
//                     D3DX_DEFAULT,              // [in] DWORD MipFilter,
//                     0,                         // [in] D3DCOLOR ColorKey,
//                     _pD3DXIMAGE_INFO,          // [out] D3DXIMAGE_INFO *pSrcInfo,
//                     NULL,                      // [in] PALETTEENTRY *pPalette,
//                     &pIDirect3DTexture9        // [out] LPDIRECT3DTEXTURE9* ppTexture
//                );

    //TODO:A`GCAX̎̂
    //     eNX`[̑ɃT[tFCXB
    //    HRESULT CreateRenderTarget(
    //        UINT Width,
    //        UINT Height,
    //        D3DFORMAT Format,
    //        D3DMULTISAMPLE_TYPE MultiSample,
    //        DWORD MultisampleQuality,
    //        BOOL Lockable,
    //        IDirect3DSurface9** ppSurface,
    //        HANDLE* pHandle
    //    );


    returnWhenFailed(hr, D3D_OK, "_O^[QbgeNX`("<<GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH)<<"x"<<GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT)<<")̍쐬ɎsB\nTCYmFĉB");
    //RenderTarget(`)eNX`֐؂ւ
    hr = _pRenderTexture->GetSurfaceLevel(0, &_pRenderTextureSurface);
    returnWhenFailed(hr, D3D_OK, "_O^[QbgeNX`̃T[tFCX擾Ɏs܂B");
    hr = GgafDxGod::_pID3DDevice9->SetRenderTarget(0, _pRenderTextureSurface);
    returnWhenFailed(hr, D3D_OK, "_O^[QbgeNX` SetRenderTarget o܂łB");


    //eNX`ɕ`悷ۂ̐[xobt@pT[tFCXʓr쐬
    hr = GgafDxGod::_pID3DDevice9->CreateDepthStencilSurface(
            GGAF_PROPERTY(RENDER_TARGET_BUFFER_WIDTH),
            GGAF_PROPERTY(RENDER_TARGET_BUFFER_HEIGHT),
            _paPresetPrm[0].AutoDepthStencilFormat, //D3DFORMAT           Format,
            _paPresetPrm[0].MultiSampleType,        //D3DMULTISAMPLE_TYPE MultiSample,
            _paPresetPrm[0].MultiSampleQuality,     //DWORD               MultisampleQuality,
            TRUE,                                   //BOOL                Discard, SetDepthStencileSurface֐Ő[xobt@ύXɃobt@j邩ǂ
            &_pRenderTextureZ,                      //IDirect3DSurface9** ppSurface,
            NULL                                    //HANDLE*             pHandle ݖgp
    );
    //[xobt@쐬́A[xobt@pT[tFCXLɕύX
    returnWhenFailed(hr, D3D_OK, "_O^[QbgeNX`Zobt@쐬Ɏs܂B");
    hr =  GgafDxGod::_pID3DDevice9->SetDepthStencilSurface(_pRenderTextureZ);
    returnWhenFailed(hr, D3D_OK, "_O^[QbgeNX` SetDepthStencilSurface o܂łB");
    //wiFŃNA
    hr = GgafDxGod::_pID3DDevice9->Clear(0, NULL, D3DCLEAR_TARGET, _color_border, 1.0f, 0);
    hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
    hr = GgafDxGod::_pID3DDevice9->Clear(0, NULL, D3DCLEAR_TARGET, _color_border, 1.0f, 0);
    returnWhenFailed(hr, D3D_OK,  "NAF(_color_border)̓hԂAʃNAɎs܂B");

    //A_v^Ɋ֘AtꂽXbv`F[擾ăobNobt@擾
    hr = GgafDxGod::_pID3DDevice9->GetSwapChain( 0, &_apSwapChain[0] );
    returnWhenFailed(hr, D3D_OK, "Xbv`FC擾Ɏs܂B");
    hr = _apSwapChain[0]->GetBackBuffer( 0, D3DBACKBUFFER_TYPE_MONO, &_apBackBuffer[0] );
    returnWhenFailed(hr, D3D_OK, "Xbv`FCA^[Qbg̃obNobt@擾Ɏs܂B");
    if (GGAF_PROPERTY(DUAL_VIEW)) {
        hr = GgafDxGod::_pID3DDevice9->GetSwapChain( 1, &_apSwapChain[1] );
        returnWhenFailed(hr, D3D_OK, "Qʖڂ̃Xbv`FC擾Ɏs܂B\n}`fBXvCɖ蔭܂B");
        hr = _apSwapChain[1]->GetBackBuffer( 0, D3DBACKBUFFER_TYPE_MONO, &_apBackBuffer[1] );
        returnWhenFailed(hr, D3D_OK, "Qʖڂ̃Xbv`FCA^[Qbg̃obNobt@擾Ɏs܂B");
    }

    //tXN[AobNobt@ƃtgobt@wiFœh
    if (GGAF_PROPERTY(DUAL_VIEW)) {
        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[0],
                _apBackBuffer[0]      , &_aRect_ViewScreen[0],
                D3DTEXF_NONE);
        checkDxException(hr, D3D_OK, "FULL_SCREEN DUAL_VIEW 1ʖځAwiFhɎs܂B(1)\n"<<
                                     "_pRenderTextureSurface="<<_pRenderTextureSurface<<"/_apBackBuffer[0]="<<_apBackBuffer[0]);

        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[1],
                _apBackBuffer[1]      , &_aRect_ViewScreen[1],
                D3DTEXF_NONE);
        checkDxException(hr, D3D_OK, "FULL_SCREEN DUAL_VIEW 2ʖځAwiFhɎs܂B(1)\n"<<
                                      "_pRenderTextureSurface="<<_pRenderTextureSurface<<"/_apBackBuffer[0]="<<_apBackBuffer[0]);
    } else {
        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_rectRenderTargetBuffer,
                _apBackBuffer[0]      , &_aRect_ViewScreen[0],
                D3DTEXF_NONE);
        checkDxException(hr, D3D_OK, "FULL_SCREEN wiFhɎs܂B(1)");
    }

    hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
    returnWhenFailed(hr, D3D_OK, "Present(NULL, NULL, NULL, NULL)Ɏs܂B");
    //tbvĂxwiFœh
    if (GGAF_PROPERTY(DUAL_VIEW)) {
        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[0],
                _apBackBuffer[0]      , &_aRect_ViewScreen[0],
                D3DTEXF_NONE);
        checkDxException(hr, D3D_OK, "FULL_SCREEN DUAL_VIEW 1ʖځAwiFhɎs܂B(2)\n"<<
                                     "_pRenderTextureSurface="<<_pRenderTextureSurface<<"/_apBackBuffer[0]="<<_apBackBuffer[0]);

        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[1],
                _apBackBuffer[1]      , &_aRect_ViewScreen[1],
                D3DTEXF_NONE);
        checkDxException(hr, D3D_OK, "FULL_SCREEN DUAL_VIEW 2ʖځAwiFhɎs܂B(2)\n"<<
                                      "_pRenderTextureSurface="<<_pRenderTextureSurface<<"/_apBackBuffer[0]="<<_apBackBuffer[0]);
    } else {
        hr = GgafDxGod::_pID3DDevice9->StretchRect(
                _pRenderTextureSurface, &_rectRenderTargetBuffer,
                _apBackBuffer[0]      , &_aRect_ViewScreen[0],
                D3DTEXF_NONE
                );
        checkDxException(hr, D3D_OK, "FULL_SCREEN wiFhɎs܂B(2)");
    }
    //ʂȊAVISTAXP̂QʖڃtXN[[h
    //  Ή̂͂̂悤ȃR[hȂƂ_B


    if (GGAF_PROPERTY(DUAL_VIEW)) {
        //Qʖڂ̃EBhEʒu␳
        EnumDisplayMonitors(NULL, NULL, GgafDxGod::getSecondaryMoniterPixcoordCallback, (LPARAM)this);
        _TRACE_("Qʖڂ̍W("<<_secondary_screen_x<<","<<_secondary_screen_y<<")");
        ShowWindow(_pHWndSecondary, SW_SHOWNORMAL);
        UpdateWindow(_pHWndSecondary);
        SetWindowPos(_pHWndSecondary,
                     HWND_TOPMOST,
                     _secondary_screen_x, _secondary_screen_y, 0, 0,
                     SWP_SHOWWINDOW | SWP_NOSIZE );
        //sȂĂȂƁANAQʖڂ̗̈NbNہA
        //ĂуtXN[Ă܂B
        //Pʖڂ̓tXN[ɂȂĂAWindow̍オ(0,0)̂߃YȂ̂ŁA
        //SetWindowPos͂ԂsvBÔ߂ɓl̏sB
        ShowWindow(_pHWndPrimary, SW_SHOWNORMAL);
        UpdateWindow(_pHWndPrimary);
        SetWindowPos(_pHWndPrimary,
                     HWND_TOPMOST,
                     0, 0, 0, 0,
                     SWP_SHOWWINDOW | SWP_NOSIZE);
    } else {
        ShowWindow(_pHWndPrimary, SW_SHOWNORMAL);
        UpdateWindow(_pHWndPrimary);
        SetWindowPos(_pHWndPrimary,
                     HWND_TOPMOST,
                     0, 0, 0, 0,
                     SWP_SHOWWINDOW | SWP_NOSIZE);
    }

    return D3D_OK;
}



HRESULT GgafDxGod::releaseFullScreenRenderTarget() {
    RELEASE_SAFETY(_pRenderTextureSurface);
    RELEASE_SAFETY(_pRenderTexture);
    RELEASE_SAFETY(_pRenderTextureZ);
    RELEASE_SAFETY(_apBackBuffer[0]);
    RELEASE_SAFETY(_apSwapChain[0]);
    if (GGAF_PROPERTY(DUAL_VIEW)) {
        RELEASE_SAFETY(_apBackBuffer[1]);
        RELEASE_SAFETY(_apSwapChain[1]);
    }
    return D3D_OK;
}

void GgafDxGod::presentUniversalMoment() {
    if (_is_device_lost_flg) {
        return;
    } else {
        GgafGod::presentUniversalMoment();
    }
}

void GgafDxGod::executeUniversalJudge() {
    if (_is_device_lost_flg) {
        return;
    } else {
        GgafGod::executeUniversalJudge();
    }
}
void GgafDxGod::makeUniversalMaterialize() {
    if (_is_device_lost_flg) {
        return;
    }
    TRACE("GgafDxGod::materialize() start");
    HRESULT hr;
        //ʏ펞

    //obt@NA
    hr = GgafDxGod::_pID3DDevice9->Clear(0, // NA`̈̐
                                         NULL, // `̈
                                         D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, // _O^[QbgƐ[xobt@NA
                                         _color_clear, //NAFinot wiFj
                                         1.0f,         // Zobt@̃NAl
                                         0             // XeVobt@̃NAl
                                        );
    checkDxException(hr, D3D_OK, "GgafDxGod::_pID3DDevice9->Clear() Ɏs܂B");

    //`掖O
    hr = GgafDxGod::_pID3DDevice9->BeginScene();
    checkDxException(hr, D3D_OK, "GgafDxGod::_pID3DDevice9->BeginScene() Ɏs܂B");
    //SċIi`j
#ifdef MY_DEBUG
    GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_FILLMODE, GgafDxGod::_d3dfillmode);
#endif
    GgafGod::makeUniversalMaterialize(); //X[p[materializes
    //`掖㏈
    hr = GgafDxGod::_pID3DDevice9->EndScene();
    checkDxException(hr, D3D_OK, "GgafDxGod::_pID3DDevice9->EndScene() Ɏs܂B");

    TRACE("GgafDxGod::makeUniversalMaterialize() end");
}

void GgafDxGod::presentUniversalVisualize() {
    //A
    //if (GgafDxGod::_pID3DDevice9->Present(NULL,&_aRect_Present[0],NULL,NULL) == D3DERR_DEVICELOST) {
    //        static D3DRASTER_STATUS rs;
    //        while (SUCCEEDED(GgafDxGod::_pID3DDevice9->GetRasterStatus(0, &rs)) ) {
    //            if(rs.InVBlank) {
    //                break; //AԂł͂Ȃ
    //            } else {
    //                Sleep(1);
    //            }
    //        }
    HRESULT hr;
    if (_is_device_lost_flg != true) {
        if (_adjustGameScreen && _pHWnd_adjustScreen) {
            adjustGameScreen(_pHWndPrimary);
            adjustGameScreen(_pHWndSecondary);
        }

        //Present
        if (GGAF_PROPERTY(FULL_SCREEN)) {
            if (GGAF_PROPERTY(DUAL_VIEW)) {
                //QʎgpEtXN[
                //ʂOobNobt@ʂPobNobt@փRs[
                hr = GgafDxGod::_pID3DDevice9->StretchRect(
                        _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[0],
                        _apBackBuffer[0]      , &_aRect_Present[0],
                        D3DTEXF_LINEAR); //TODO:D3DTEXF_LINEARIvVwɂ邩H
                checkDxException(hr, D3D_OK, "FULL_SCREEN DUAL_VIEW 1ʖ StretchRect() Ɏs܂B\n_pRenderTextureSurface="<<_pRenderTextureSurface<<"/_apBackBuffer[0]="<<_apBackBuffer[0]);

                hr = GgafDxGod::_pID3DDevice9->StretchRect(
                        _pRenderTextureSurface, &_aRect_HarfRenderTargetBuffer[1],
                        _apBackBuffer[1]      , &_aRect_Present[1],
                        D3DTEXF_LINEAR);
                checkDxException(hr, D3D_OK, "StretchRect() Ɏs܂B");

                hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
            } else {
                //PʎgpEtXN[
                hr = GgafDxGod::_pID3DDevice9->StretchRect(
                        _pRenderTextureSurface,
                        &_rectRenderTargetBuffer,
                        _apBackBuffer[0],
                        &_aRect_Present[0],
                        D3DTEXF_LINEAR);
                checkDxException(hr, D3D_OK, "FULL 1gamen StretchRect() Ɏs܂B");

                hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
            }
        } else {
            if (GGAF_PROPERTY(DUAL_VIEW)) {
                //QʎgpEEBhE[h
                if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                    //cŒ胂[h
                    hr = GgafDxGod::_pID3DDevice9->Present(&_aRect_HarfRenderTargetBuffer[0], &_aRect_Present[0], NULL, NULL);
                    if (hr == D3D_OK) {
                        hr = GgafDxGod::_pID3DDevice9->Present(&_aRect_HarfRenderTargetBuffer[1], &_aRect_Present[1], _pHWndSecondary, NULL);
                    }
                } else {
                    //cXgb`[h
                    hr = GgafDxGod::_pID3DDevice9->Present(&_aRect_HarfRenderTargetBuffer[0], NULL, NULL, NULL);
                    if (hr == D3D_OK) {
                        hr = GgafDxGod::_pID3DDevice9->Present(&_aRect_HarfRenderTargetBuffer[1], NULL, _pHWndSecondary, NULL);
                    }
                }
            } else {
                //PʎgpEEBhE[h
                if (GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
                    //cŒ胂[h
                    hr = GgafDxGod::_pID3DDevice9->Present(NULL, &_aRect_Present[0], NULL, NULL);
                } else {
                    //cXgb`[h
                    hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
                }
            }
        }

        if (hr != D3D_OK) { //hr  Present ̖߂l
             //onّfIlH
//            _TRACE_("xfoCXُ픭!!" <<DXGetErrorString(hr) << " "<< DXGetErrorDescription(hr));
            _TRACE_("xfoCXُ픭!! HRESULT="<<hr);
            if (hr == D3DERR_DEVICELOST) {
                _TRACE_("ʏ̐foCXXgI");
            }

            Sleep(100); // 1b҂
            _TRACE_("yfoCXXgzBEGIN ------>");

            //Hx~
            _TRACE_("yfoCXXgzH~ BEGIN ------>");
            int cnt = 0;
            GgafFactory::beginRest();
         ___EndSynchronized1; // <----- rI
            for (int i = 0; GgafFactory::isResting() == false; i++) {
                Sleep(10); //Hꂪ܂ő҂
                if (i > 5*60*100) {
                    _TRACE_("yfoCXXg/H~z 5ҋ@܂AHꂩ甽܂Bbreak܂Bv");
                    break;
                }
            }
         ___BeginSynchronized1; // ----->rJn
            _TRACE_("yfoCXXgzH~ <-------- END");

            _TRACE_("yfoCXXgz\[X BEGIN ------>");

            //_O^[QbgAfoCXXg
            if (GGAF_PROPERTY(FULL_SCREEN)) {
                releaseFullScreenRenderTarget();
            }
            //}bveNX`AfoCXXg
            GgafDxGod::_pCubeMapTextureManager->releaseAll();
            //GtFNgAfoCXXg
            GgafDxGod::_pEffectManager->onDeviceLostAll();
            //f
            GgafDxGod::_pModelManager->onDeviceLostAll();
            //Sm[hɉȂCxg
            getUniverse()->throwEventToLowerTree(GGAF_EVENT_ON_DEVICE_LOST, this);
            _TRACE_("yfoCXXgz\[X <-------- END");
            _is_device_lost_flg = true;
        }
    }

    if (_is_device_lost_flg) {
        _TRACE_("yfoCXXg/\[Xzx`FbN BEGIN ------>");
        //for(int i = 0; i < 300; i++) {
        while(true) {
            if (_can_wddm) {
                hr = ((IDirect3DDevice9Ex*)GgafDxGod::_pID3DDevice9)->CheckDeviceState(_pHWndPrimary);
                if (hr == D3DERR_DEVICELOST || hr == S_PRESENT_OCCLUDED) {
                    return;
                } else {
                    break;
                }
            } else {
                hr = GgafDxGod::_pID3DDevice9->TestCooperativeLevel();
                if (hr == D3DERR_DEVICELOST) {
                    return;
                } else {
                    break;
                }
            }
        }
        _TRACE_("yfoCXXg/\[Xzx`FbN <-------- END");

        //foCXZbg݂
        _TRACE_("yfoCXXgzfoCXZbg BEGIN ------>");
        for(int i = 0; i < 100*60*10; i++) {
            if (GGAF_PROPERTY(FULL_SCREEN) && GGAF_PROPERTY(DUAL_VIEW)) {
                hr = GgafDxGod::_pID3DDevice9->Reset(_paPresetPrm);
            } else {
                hr = GgafDxGod::_pID3DDevice9->Reset(&(_paPresetPrm[0]));
            }
            if (hr != D3D_OK) {
                if (hr == D3DERR_DRIVERINTERNALERROR) {
                    Sleep(10);
                    return;
                } else if (hr == D3DERR_DRIVERINTERNALERROR) {
                    throwGgafDxCriticalException(hr, "yfoCXXg/foCXZbgzD3DERR_DRIVERINTERNALERRORBI܂B");
                } else if (hr == D3DERR_OUTOFVIDEOMEMORY) {
                    throwGgafDxCriticalException(hr, "yfoCXXg/foCXZbgzD3DERR_OUTOFVIDEOMEMORYB܂BI܂B");
                } else {
                    Sleep(10);
                    return;
                }
            } else {
                break;
            }
        }
        _TRACE_("yfoCXXgzfoCXZbg <-------- END");


        //foCXĐݒ
        _TRACE_("yfoCXXgzfoCXč\z BEGIN ------>");
        initDx9Device();
        _TRACE_("yfoCXXgzfoCXč\z <-------- END");

        if (GGAF_PROPERTY(FULL_SCREEN)) {
            _TRACE_("yfoCXXgztXN[_O^[QbgeNX`č\z BEGIN ------>");
            restoreFullScreenRenderTarget();
            _TRACE_("yfoCXXgztXN[_O^[QbgeNX`č\z <-------- END");
        }

        //\[Xč\z
        _TRACE_("yfoCXXgz\[Xč\z BEGIN ------>");
        //}bveNX`AA
        GgafDxGod::_pCubeMapTextureManager->restoreAll();
        //GtFNgZbg
        GgafDxGod::_pEffectManager->restoreAll();
        //fĐݒ
        GgafDxGod::_pModelManager->restoreAll();
        //Sm[hɍĐݒ肵ȂCxg
        getUniverse()->throwEventToLowerTree(GGAF_EVENT_DEVICE_LOST_REDEPOSITORY, this);
        //O`惂f𖳌ɂ
        GgafDxModelManager::_pModelLastDraw = NULL;
        _is_device_lost_flg = false;
        _TRACE_("yfoCXXgz\[Xč\z <-------- END");

        //HĊJ
        _TRACE_("yfoCXXgzHċN BEGIN ------>");
        GgafFactory::finishRest();
        _TRACE_("yfoCXXgzHċN <-------- END");

        _TRACE_("yfoCXXgz<-------- END");

        Sleep(500);
        hr = GgafDxGod::_pID3DDevice9->Clear(0,    // NA`̈̐
                                             NULL, // `̈
                                             D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, // _O^[QbgƐ[xobt@NA
                                             _color_border, //wiF      //D3DCOLOR_XRGB( 0, 0, 0 )
                                             1.0f, // Zobt@̃NAl
                                             0     // XeVobt@̃NAl
                                            );
    }
}

void GgafDxGod::finalizeUniversal() {
    if (_is_device_lost_flg) {
        return;
    } else {
        GgafGod::finalizeUniversal();
    }
}

void GgafDxGod::clean() {
    if (!_was_cleaned) {
        _TRACE_("GgafDxGod::clean() begin");
        for(int i = 0; i < 8; ++i) { GgafDxGod::_pID3DDevice9->SetTexture( i, NULL ); }
        for(int i = 0; i < 8; ++i) { GgafDxGod::_pID3DDevice9->SetStreamSource( i, NULL, 0, 0 ); }
        GgafDxGod::_pID3DDevice9->SetIndices( NULL );
        GgafDxGod::_pID3DDevice9->SetPixelShader( NULL );
        GgafDxGod::_pID3DDevice9->SetVertexShader( NULL );
        GgafDxGod::_pID3DDevice9->SetVertexDeclaration( NULL );

        GgafGod::clean();

        CmRandomNumberGenerator::getInstance()->release();
        //ێf
        DELETE_IMPOSSIBLE_NULL(_pCubeMapTextureManager);
        DELETE_IMPOSSIBLE_NULL(_pModelManager);
        DELETE_IMPOSSIBLE_NULL(_pEffectManager);
        _TRACE_("GgafDxGod::clean() end");
    }
}

void GgafDxGod::adjustGameScreen(HWND prm_pHWnd) {
    RECT rect;
    if (prm_pHWnd && !GGAF_PROPERTY(FULL_SCREEN) && GGAF_PROPERTY(FIXED_GAME_VIEW_ASPECT)) {
        HRESULT hr;
        hr = GgafDxGod::_pID3DDevice9->Clear(0, NULL, D3DCLEAR_TARGET, _color_border, 1.0f, 0);
        hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, NULL, NULL);
        if (GGAF_PROPERTY(DUAL_VIEW)) {
            hr = GgafDxGod::_pID3DDevice9->Present(NULL, NULL, _pHWndSecondary, NULL);
        }
        if (::GetClientRect(prm_pHWnd, &rect)) {
            LONG width = rect.right;
            LONG height = rect.bottom;
            LONG fix_width, fix_height;
            int pos1, pos2;
            if (GGAF_PROPERTY(DUAL_VIEW)) {
                fix_width  = GGAF_PROPERTY(GAME_BUFFER_WIDTH)/2;
                fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                pos1 = GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION1);
                pos2 = GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2);
            } else {
                fix_width  = GGAF_PROPERTY(GAME_BUFFER_WIDTH);
                fix_height = GGAF_PROPERTY(GAME_BUFFER_HEIGHT);
                pos1 = GGAF_PROPERTY(SINGLE_VIEW_DRAW_POSITION);
                pos2 = GGAF_PROPERTY(DUAL_VIEW_DRAW_POSITION2); //Ƃ肠
            }

            if (1.0f * width / height > 1.0f * fix_width / fix_height) {
                //艡ɂȂĂ܂Ă
                double rate = 1.0 * height / fix_height; //k=c̔䗦
                if (prm_pHWnd == _pHWndPrimary) {
                    _aRect_Present[0].left   = (width / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[0].top    = 0;
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                    positionPresentRect(pos1, _aRect_Present[0], width, height);
                } else {
                    _aRect_Present[1].left   = (width / 2.0) - (fix_width * rate / 2.0);
                    _aRect_Present[1].top    = 0;
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                    positionPresentRect(pos2, _aRect_Present[1], width, height);
                }

            } else {
                //cɂȂĂ܂Ă
                double rate = 1.0 * width / fix_width; //k=̔䗦
                if (prm_pHWnd == _pHWndPrimary) {
                    _aRect_Present[0].left   = 0;
                    _aRect_Present[0].top    = (height / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[0].right  = _aRect_Present[0].left + (fix_width * rate);
                    _aRect_Present[0].bottom = _aRect_Present[0].top  + (fix_height * rate);
                    positionPresentRect(pos1, _aRect_Present[0], width, height);
                } else {
                    _aRect_Present[1].left   = 0;
                    _aRect_Present[1].top    = (height / 2.0) - (fix_height * rate / 2.0);
                    _aRect_Present[1].right  = _aRect_Present[1].left + (fix_width * rate);
                    _aRect_Present[1].bottom = _aRect_Present[1].top  + (fix_height * rate);
                    positionPresentRect(pos2, _aRect_Present[1], width, height);
                }
            }
        }
    } else {
        if (::GetClientRect(prm_pHWnd, &rect)) {
            if (prm_pHWnd == _pHWndPrimary) {
                _aRect_Present[0] = rect;
            } else {
                _aRect_Present[1] = rect;
            }

        }
    }
    GgafDxGod::_pID3DDevice9->GetViewport(&(P_CAM->_viewport));
    _adjustGameScreen = false;
    _pHWnd_adjustScreen = NULL;
}

void GgafDxGod::positionPresentRect(int prm_pos, RECT& out_rectPresent, pixcoord prm_screen_width, pixcoord prm_screen_height) {
    // V@W@X
    // @_b^
    // S[T[U
    // @^b_
    // P@Q@R
    //1:A2:A3:EA4:A5:^񒆁A6:EA7:A8:A9:E
    if (prm_pos == 5) {
        return;
    }
    if (prm_pos == 7 || prm_pos == 8 || prm_pos == 9) {
        out_rectPresent.bottom = out_rectPresent.bottom - out_rectPresent.top;
        out_rectPresent.top = 0;
    } else if (prm_pos == 1 || prm_pos == 2 || prm_pos == 3) {
        out_rectPresent.top = prm_screen_height - (out_rectPresent.bottom - out_rectPresent.top);
        out_rectPresent.bottom = prm_screen_height;
    }

    if (prm_pos == 7 || prm_pos == 4 || prm_pos == 1) {
        out_rectPresent.right = out_rectPresent.right - out_rectPresent.left;
        out_rectPresent.left = 0;
    } else if (prm_pos == 9 || prm_pos == 6 || prm_pos == 3) {
        out_rectPresent.left = prm_screen_width - (out_rectPresent.right - out_rectPresent.left);
        out_rectPresent.right = prm_screen_width;
    }
}

GgafDxGod::~GgafDxGod() {

    clean();
    _was_cleaned = true;
    //DirectSound
    GgafDxSound::release();
    //DirectInput
    GgafDxInput::release();

    if(GGAF_PROPERTY(FULL_SCREEN)) {
        releaseFullScreenRenderTarget();
    }

    _TRACE_("_pID3DDevice9 [");
    Sleep(60);
    DELETEARR_IMPOSSIBLE_NULL(_paPresetPrm);
    DELETEARR_IMPOSSIBLE_NULL(_paDisplayMode);
    RELEASE_IMPOSSIBLE_NULL(_pID3DDevice9);
    RELEASE_IMPOSSIBLE_NULL(_pID3D9);

}




// 2011/07/26
//
//yPʃEBhE[hz
//                                 QQQQQQQQQQQQQQQQQQQQQ
//                               ^                                        ^
//    tgobt@         ^                                        ^
//    (EChE)           ^                                        ^
//                           PPPPPPPPPPPPPPPPPPPPP
//                           SINGLE_VIEW_WINDOW_WIDTH x SINGLE_VIEW_WINDOW_HEIGHT
//
//                                               
//                                               b Present
//                                               b(D3DSWAPEFFECT_COPY)
//                                               b
//                                  QQQQQQQQQQQQQQQQQQQQQ
//    obNobt@              ^                                        ^
//                              ^                                        ^ Draw   QQQ
//                            ^                                        ^      ^    ^Q[obt@
//                            PPPPPPPPPPPPPPPPPPPPP          PPP
//                       RENDER_TARGET_BUFFER_WIDTH x RENDER_TARGET_BUFFER_HEIGHT
//
//
//---------------------------------------------------------------------------------------------
//
//
//yQʃEBhE[hz
//                            QQQQQQQQQQQ             QQQQQQQQQQQ
//                          ^                    ^           ^                    ^
//    tgobt@    ^                    ^           ^                    ^
//    (EChE)      ^                    ^           ^                    ^
//                      PPPPPPPPPPP             PPPPPPPPPPP
//                     DUAL_VIEW_WINDOW1_WIDTH x            DUAL_VIEW_WINDOW2_WIDTH x
//                       DUAL_VIEW_WINDOW1_HEIGHT             DUAL_VIEW_WINDOW2_HEIGHT
//
//                                                                
//                                 b Present                       b Present
//                                 b(D3DSWAPEFFECT_COPY)           b (D3DSWAPEFFECT_COPY)
//
//                                  QQQQQQQQQQQQQQQQQQQQQ
//    obNobt@              ^                                        ^
//                              ^                                        ^ Draw   QQQ
//                            ^                                        ^      ^    ^Q[obt@
//                            PPPPPPPPPPPPPPPPPPPPP          PPP
//                    RENDER_TARGET_BUFFER_WIDTH x RENDER_TARGET_BUFFER_HEIGHT
//
//
//---------------------------------------------------------------------------------------------
//
//
//yPʃtXN[[hz
//                                         QQQQQQQQQQQQQQQQ
//                                       ^                              ^
//                                     ^                              ^
//    tgobt@               ^                              ^
//    (fBXvC)               ^                              ^
//                               ^                              ^
//                               PPPPPPPPPPPPPPPP
//                                SINGLE_VIEW_FULL_SCREEN_WIDTH x
//                                  SINGLE_VIEW_FULL_SCREEN_HEIGHT
//
//                                                 
//                                                 b Present
//                                                 b(D3DSWAPEFFECT_DISCARD)
//                                        QQQQQQQQQQQQQQQQ
//                                      ^                              ^
//                                    ^                              ^
//    obNobt@                ^      _apBackBuffer[0]        ^
//                                ^                              ^
//                              ^                              ^
//                              PPPPPPPPPPPPPPPP
//                               SINGLE_VIEW_FULL_SCREEN_WIDTH x
//                                 SINGLE_VIEW_FULL_SCREEN_HEIGHT
//
//                                                 
//                                                 b StretchRect
//                                                 b
//                                 QQQQQQQQQQQQQQQQQQQQQ
//    _[^[Qbg         ^                                        ^
//    eNX`[             ^       _pRenderTextureSurface           ^ Draw   QQQ
//                           ^                                        ^      ^    ^Q[obt@
//                           PPPPPPPPPPPPPPPPPPPPP          PPP
//                     RENDER_TARGET_BUFFER_WIDTH x RENDER_TARGET_BUFFER_HEIGHT
//
//
//---------------------------------------------------------------------------------------------
//
//
//yQʃtXN[[hz
//                            QQQQQQQQQQQ     |        QQQQQQQQQQQ
//                          ^                    ^     |      ^                    ^
//    tgobt@    ^                    ^       |    ^                    ^
//    (fBXvC)    ^                    ^         |  ^                    ^
//                      PPPPPPPPPPP           |  PPPPPPPPPPP
//                     DUAL_VIEW_FULL_SCREEN1_WIDTH x    |   DUAL_VIEW_FULL_SCREEN2_WIDTH x
//                       DUAL_VIEW_FULL_SCREEN1_HEIGHT   |     DUAL_VIEW_FULL_SCREEN2_HEIGHT
//
//                                                                
//                               b Present                         b Present
//                               b(D3DSWAPEFFECT_DISCARD)          b (D3DSWAPEFFECT_DISCARD)
//
//                            QQQQQQQQQQQ             QQQQQQQQQQQ
//                          ^                    ^           ^                    ^
//    obNobt@      ^  _apBackBuffer[0]  ^           ^  _apBackBuffer[1]  ^
//                      ^                    ^           ^                    ^
//                      PPPPPPPPPPP             PPPPPPPPPPP
//                     DUAL_VIEW_FULL_SCREEN1_WIDTH x        DUAL_VIEW_FULL_SCREEN2_WIDTH x
//                       DUAL_VIEW_FULL_SCREEN1_HEIGHT         DUAL_VIEW_FULL_SCREEN2_HEIGHT
//
//                                                                
//                                    b StretchRect                b StretchRect
//                                    b                            b
//                                  QQQQQQQQQQQQQQQQQQQQQ
//    _[^[Qbg          ^                                        ^
//    eNX`[              ^       _pRenderTextureSurface           ^ Draw   QQQ
//                            ^                                        ^      ^    ^Q[obt@
//                            PPPPPPPPPPPPPPPPPPPPP          PPP
//                       RENDER_TARGET_BUFFER_WIDTH x RENDER_TARGET_BUFFER_HEIGHT




//ĂP
//                 <-------------------------------------------- 2048 --------------------------------------------->
//                 <--------- 512 --------->
//                 <------------------------- 1600 ------------------------------------------><------ 448 --------->
//
//         ^       +-----------------------+-----------------------+-----------------------+-+---------------------+
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//        512      |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         |       |                       |                       |                       | |                     |
//         v       +-----------------------+-----------------------+-----------------------+-+---------------------+
//                                                                                         >-<-- 64


//ĂQ
//                 <-------------------------------------------- 2048 --------------------------------------------->
//                 <--------- 512 --------->
//                 <------------------------- 1280 ----------------------------><-------------- 768 --------------->
//
//         ^   ^   +-----------------------+-----------------------+-----------+-----------+-----------------------+
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//        512 480  |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   |   |                       |                       |           |           |                       |
//         |   v   +-----------------------+-----------------------+-----------+           |                       |
//         v  32   +-----------------------+-----------------------+-----------------------+-----------------------+
//
//                                                                 <----256----><---256---->


