#include "stdafx.h"
using namespace GgafCore;
using namespace GgafDxCore;

GgafDxDrawableActor* GgafDxUniverse::_apAlphaActorFirstList_DrawDepthLevel[MAX_DRAW_DEPTH_LEVEL+1];
GgafDxDrawableActor* GgafDxUniverse::_apAlphaActorLastList_DrawDepthLevel[MAX_DRAW_DEPTH_LEVEL+1];
GgafDxDrawableActor* GgafDxUniverse::_pActors_DrawMaxDrawDepth = NULL;
GgafDxDrawableActor* GgafDxUniverse::_pActor_DrawActive = NULL;

coord GgafDxUniverse::_X_goneLeft   = 0;
coord GgafDxUniverse::_X_goneRight  = 0;
coord GgafDxUniverse::_Y_goneTop    = 0;
coord GgafDxUniverse::_Y_goneBottom = 0;
coord GgafDxUniverse::_Z_goneFar   = 0;
coord GgafDxUniverse::_Z_goneNear  = 0;


GgafDxUniverse::SeArray::SeArray() {
    _p = 0;
    for (int i = 0; i < MAX_SE_AT_ONCE; i++) {
        _apSe[i] = NULL;
    }
}

void GgafDxUniverse::SeArray::add(GgafDxSe* prm_pSe, int prm_volume, float prm_pan, float prm_rate_frequency) {
    if (_p < MAX_SE_AT_ONCE) {
        _apSe[_p] = prm_pSe;
        _rate_frequency[_p] = prm_rate_frequency;
        _volume[_p] = prm_volume;
        _pan[_p] = prm_pan;
        _p++;
    }
}

void GgafDxUniverse::SeArray::play(int index) {
    _apSe[index]->play(_volume[index], _pan[index], _rate_frequency[index]);
    _apSe[index] = NULL;
}

GgafDxUniverse::GgafDxUniverse(const char* prm_name, GgafDxCamera* prm_pCamera) : GgafUniverse(prm_name) {
    _obj_class |= Obj_GgafDxUniverse;
    _class_name = "GgafDxUniverse";
    for (int i = 0; i < MAX_DRAW_DEPTH_LEVEL+1; i++) {
        _apAlphaActorFirstList_DrawDepthLevel[i] = NULL;
        _apAlphaActorLastList_DrawDepthLevel[i] = NULL;
    }
    //ɃJNEWĂȂƂȂB
    _pCamera = prm_pCamera;


    getDirector()->addSubGroup(_pCamera);
    _pActor_DrawActive = NULL;

    //J̎ʂ͈́B
    coord F = DX_C(_pCamera->_zf);
    _X_goneRight  = +F;
    _X_goneLeft   = -F;
    _Y_goneTop    = +F;
    _Y_goneBottom = -F;
    _Z_goneFar    = +F;
    _Z_goneNear   = -F;
    _TRACE_("Gone=X ("<<_X_goneLeft<<" ~ "<<_X_goneRight<<") Y("<<_Y_goneBottom<<" ~ "<<_Y_goneTop<<") Z("<<_Z_goneFar<<" ~ "<<_Z_goneNear<<")");

    _pRing_pSeArray = NEW GgafLinkedListRing<SeArray>();
    for (int i = 0; i < MAX_SE_DELAY; i++) { //GGAF_SAYONARA_DELAY͍őxt[ASE̒x̍ōt[ƂĂg
        _pRing_pSeArray->addLast(NEW SeArray(), true);
    }
    GgafRepeatSeq::create("_SE_D_", 0, 8); //YSEĐt[

//    _pCubeMapTextureManager = NEW GgafDxTextureManager("CMTexManager");
}

void GgafDxUniverse::registSe(GgafDxSe* prm_pSe, int prm_volume, float prm_pan, float prm_rate_frequency, int prm_delay ) {
    int bpm = GgafDxBgmPerformer::_active_bgm_bpm;
    //Yt[vZ
    //1Ԃ60*60=3600t[
    //4^C~O 3600/_bpm
    //8^C~O 3600/(_bpm*2) = 1800/_bpm
    //16^C~O 3600/(_bpm*4) = 900/_bpm
    //0t[BGMƂāÃ݂t[fƂƁAߖ16^C~O
    //F = f%(900/_bpm)
    //F = 0̏ꍇA f
    //F != 0 ̏ꍇ {f/(900/_bpm)̏ * (900/_bpm)} + (900/_bpm) ߖ16^C~O
    //TODO:߂Ă̂ɃCx[_[GNXg[ɐĂ܂II{Vvf~BII




    //SE̖^C~O 0`8t[炵ăo
    _pRing_pSeArray->getNext(prm_delay+1+(GgafRepeatSeq::nextVal("_SE_D_")))->add(prm_pSe, prm_volume, prm_pan, prm_rate_frequency);
    //_pRing_pSeArray->getNext(prm_delay+1)->add(prm_pSe, prm_volume, prm_pan, prm_rate_frequency);
}

void GgafDxUniverse::processSettlementBehavior() {

    GgafUniverse::processSettlementBehavior();
    //SE炷
    SeArray* pSeArray = _pRing_pSeArray->next(); //i߂SEz擾
    if (pSeArray->_p > 0) {
        for (int p = 0; p < pSeArray->_p; p++) {
            pSeArray->play(p);
        }
        pSeArray->_p = 0; //Zbg
    }

    GgafRepeatSeq::setMax("_SE_D_"); //nextVal0Ԃ
}

void GgafDxUniverse::draw() {
    GgafDxModelConnection* pModelCon = GgafDxGod::_pModelManager->getFirstConnection();
    while (pModelCon) {
        pModelCon->fetch()->_pTextureBlinker->behave();
        pModelCon = (GgafDxModelConnection*)(pModelCon->getNext());
    }

    //EffectManagerŉ񂵂Vewϊݒ肷悤ɂ
    GgafDxGod::_pEffectManager->setParamPerFrameAll();

    //iK_OsviŐ[Awij̕`B
    //TODO:{͎O`̂قǂBA̓œK
    _pActor_DrawActive = _pActors_DrawMaxDrawDepth;
    GgafDxScene* pScene;
    while (_pActor_DrawActive) {
        //}X^[ݒ肷B
#ifdef MY_DEBUG
            if (_pActor_DrawActive->getPlatformScene()->_obj_class & Obj_GgafDxScene) {
                //OK
            } else {
                throwGgafCriticalException("GgafDxUniverse::draw() err1. _pActor_DrawActive["<<(_pActor_DrawActive->getName())<<"->getPlatformScene()["<<(_pActor_DrawActive->getPlatformScene()->getName())<<"]AGgafDxScene ɕϊsłBthis="<<getName());
            }
#endif
        pScene = (GgafDxScene*)(_pActor_DrawActive->getPlatformScene());
        _pActor_DrawActive->_pEffect->_pID3DXEffect->SetFloat(
                _pActor_DrawActive->_pEffect->_h_alpha_master, pScene->_master_alpha
        );
        if (_pActor_DrawActive->_alpha < 1.0f) {
            GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE); //vfƂƂŃJOꎞOFF
            //AAiK_Osvłɂ炸A\́AOオ܂\Ȃ̂ŔׂB
        }

        //`
        _pActor_DrawActive->processDraw();

        if (_pActor_DrawActive->_alpha < 1.0f) {
            GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);  //JOLɖ߂
        }
        _pActor_DrawActive = _pActor_DrawActive->_pNext_TheSameDrawDepthLevel;
    }
    _pActors_DrawMaxDrawDepth = NULL; //̂߂ɃZbg

    //iK_OKvȃIuWFNg`
    //float tmpAlpah;
    //int alphapoint = MAX_DRAW_DEPTH_LEVEL/4*3;
    for (int i = MAX_DRAW_DEPTH_LEVEL; i >= 0; i--) {
        _pActor_DrawActive = _apAlphaActorFirstList_DrawDepthLevel[i];
        while (_pActor_DrawActive) {
#ifdef MY_DEBUG
            if (_pActor_DrawActive->getPlatformScene()->_obj_class & Obj_GgafDxScene) {
                //OK
            } else {
                throwGgafCriticalException("GgafDxUniverse::draw() err2. _pActor_DrawActive["<<(_pActor_DrawActive->getName())<<"->getPlatformScene()["<<(_pActor_DrawActive->getPlatformScene()->getName())<<"]AGgafDxScene ɕϊsłBthis="<<getName());
            }
#endif
            //eV[̃J[eݒ肷B
            pScene = (GgafDxScene*)_pActor_DrawActive->getPlatformScene();
            _pActor_DrawActive->_pEffect->_pID3DXEffect->SetFloat(
                    _pActor_DrawActive->_pEffect->_h_alpha_master, pScene->_pAlphaCurtain->_alpha);

            //vf̏ꍇJOꎞOFF
            if (_pActor_DrawActive->_alpha < 1.0f) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
            }
            //Zobt@lݒ
            if (!_pActor_DrawActive->_zenable) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZENABLE, D3DZB_FALSE);
            }
            // Zobt@ݕsݒ
            if (!_pActor_DrawActive->_zwriteenable) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZWRITEENABLE, FALSE );
            }

            _pActor_DrawActive->processDraw();

            //JOLɖ߂
            if (_pActor_DrawActive->_alpha < 1.0f) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
            }
            //Zobt@lݒ
            if (!_pActor_DrawActive->_zenable) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
            }
            // Zobt@ݕsݒ
            if (!_pActor_DrawActive->_zwriteenable) {
                GgafDxGod::_pID3DDevice9->SetRenderState(D3DRS_ZWRITEENABLE, TRUE);
            }

            _pActor_DrawActive = _pActor_DrawActive->_pNext_TheSameDrawDepthLevel;
        }
        _apAlphaActorFirstList_DrawDepthLevel[i] = NULL; //̂߂ɃZbg
        _apAlphaActorLastList_DrawDepthLevel[i] = NULL;
    }

    //ŌEndPass
    HRESULT hr;
    if (GgafDxEffectManager::_pEffect_Active) {

        TRACE4("EndPass("<<GgafDxEffectManager::_pEffect_Active->_pID3DXEffect<<"): /_pEffect_Active="<<GgafDxEffectManager::_pEffect_Active->_effect_name<<"("<<GgafDxEffectManager::_pEffect_Active<<")");
        hr = GgafDxEffectManager::_pEffect_Active->_pID3DXEffect->EndPass();
        checkDxException(hr, D3D_OK, "GgafDxUniverse::processDraw() EndPass() Ɏs܂B");
        hr = GgafDxEffectManager::_pEffect_Active->_pID3DXEffect->End();
        checkDxException(hr, D3D_OK, "GgafDxUniverse::processDraw() End() Ɏs܂B");
#ifdef MY_DEBUG
        if (GgafDxEffectManager::_pEffect_Active->_begin == false) {
            throwGgafCriticalException("begin Ă܂ "<<(GgafDxEffectManager::_pEffect_Active==NULL?"NULL":GgafDxEffectManager::_pEffect_Active->_effect_name)<<"");
        } else {
            GgafDxEffectManager::_pEffect_Active->_begin = false;
        }
#endif
        GgafDxEffectManager::_pEffect_Active = NULL;
        GgafDxModelManager::_pModelLastDraw = NULL;
        GgafDxDrawableActor::_hash_technique_last_draw = 0;
    }

}

//void GgafDxUniverse::setDrawDepthMaxLevel(GgafDxDrawableActor* prm_pActor) {
//    static GgafDxDrawableActor* pActorTmp;
//    if (_pActors_DrawMaxDrawDepth == NULL) {
//        //ŏ̃AN^[̏ꍇ
//        prm_pActor->_pNext_TheSameDrawDepthLevel = NULL;
//        _pActors_DrawMaxDrawDepth = prm_pActor;
//        return;
//    } else {
//        //ɃAN^[o^ς݂ꍇ
//        pActorTmp = _pActors_DrawMaxDrawDepth;
//        prm_pActor->_pNext_TheSameDrawDepthLevel = pActorTmp;
//        _pActors_DrawMaxDrawDepth = prm_pActor;
//        return;
//    }
//}
int GgafDxUniverse::setDrawDepthLevel(int prm_draw_depth_level, GgafDxDrawableActor* prm_pActor) {
    int draw_depth_level;
    GgafDxDrawableActor* pActorTmp;
    //Jbg
    if (prm_draw_depth_level > MAX_DRAW_DEPTH_LEVEL - 4) {
        draw_depth_level = MAX_DRAW_DEPTH_LEVEL - 4;
    } else if (prm_draw_depth_level < 1) {
        draw_depth_level = 1;
    } else {
        draw_depth_level = prm_draw_depth_level;
    }

    if (_apAlphaActorFirstList_DrawDepthLevel[draw_depth_level] == NULL) {
        //prm_draw_depth_levelōŏ̃AN^[̏ꍇ
        prm_pActor->_pNext_TheSameDrawDepthLevel = NULL;
        _apAlphaActorFirstList_DrawDepthLevel[draw_depth_level] = prm_pActor;
        _apAlphaActorLastList_DrawDepthLevel[draw_depth_level] = prm_pActor;
    } else {
        if (prm_pActor->_is2DActor) {
            //Oɒǉ
            pActorTmp = _apAlphaActorFirstList_DrawDepthLevel[draw_depth_level];
            prm_pActor->_pNext_TheSameDrawDepthLevel = pActorTmp;
            _apAlphaActorFirstList_DrawDepthLevel[draw_depth_level] = prm_pActor;
        } else {
            //prm_draw_depth_levelŊɃAN^[o^ς݂ꍇ
            //\ŒɂȂȂ悤ɁAKǉ(L[)ÁAOɐςݏグ(X^bN)At[Č݂ɍsB
            //̂ȂƂ邩ƂƁAZobt@L̃eNX`ɓIuWFNgAIuWFNgꍇA
            //[xȂ̂ŁAvCIeBi`揇jɂēȂĂ܂B
            //`揇𖈃t[ω邱ƂŁAݕ\ł኱̂܂sB
            //TODO:(ۑ)QAR̃IuWFNǧ͏ꍇ͌ڂɂeł邪Ał܂Ɩ{Ƀ``B

            if ((GgafGod::_pGod->_pUniverse->_frame_of_behaving & 1) == 1) {

                //Oɒǉ
                pActorTmp = _apAlphaActorFirstList_DrawDepthLevel[draw_depth_level];
                prm_pActor->_pNext_TheSameDrawDepthLevel = pActorTmp;
                _apAlphaActorFirstList_DrawDepthLevel[draw_depth_level] = prm_pActor;
            } else {
                //Kɒǉ
                pActorTmp = _apAlphaActorLastList_DrawDepthLevel[draw_depth_level];
                pActorTmp->_pNext_TheSameDrawDepthLevel = prm_pActor;
                prm_pActor->_pNext_TheSameDrawDepthLevel = NULL;
                _apAlphaActorLastList_DrawDepthLevel[draw_depth_level] = prm_pActor;
            }
        }
    }
    return draw_depth_level;

}


GgafDxUniverse::~GgafDxUniverse() {
//DELETE_IMPOSSIBLE_NULL(_pCubeMapTextureManager);
    DELETE_IMPOSSIBLE_NULL(_pRing_pSeArray);
}
